
/*  $Header: /cvs/faces/faces/faces/addr.h,v 1.2 2002/01/15 22:58:46 devface Exp $
 *
 *  Copyright (c) 1986, 1987, 1988, 1989, 1990, 1991, by:
 *
 *      Bill Nesheim
 *      Daniel Karrenberg
 *      David Herron
 *      Rich Salz
 *      John Mackin
 *
 *  All rights reserved.
 *
 *  Permission is given to distribute these sources, as long as the
 *  copyright messages are not removed, and no monies are exchanged.
 *
 *  No responsibility is taken for any errors inherent either
 *  to the comments or the code of this program, but if reported
 *  (see README file), then an attempt will be made to fix them.
 */

#ifndef _ADDR_H
#define _ADDR_H

#include <string.h>

#ifdef  __cplusplus
extern "C" {
#endif

/* Mail address data structures. */

#define NEED_BZERO
#define NSUBDOM     20               /* # of subdomain names in domain */

typedef unsigned int MALLOCT;        /* Parameter to malloc. */

/* An address. */

typedef struct _addr {
    struct _addr *next;       /* next address in list. */
    struct _dom  *route;      /* route icl. destination domain. */
    struct _dom  *destdom;    /* destination domain. */
    char *localp;             /* RFC local part. */
    char *name;               /* Comment name. */
    char *group;              /* Group (List) phrase. */
    char *comment;            /* () comment phrase. */
    char *error;              /* error text if not NULL. */
} Addr;


/* A domain. */

typedef struct _dom {
    struct _dom *next;        /* next domain (f.i. in route). */
    char *sub[NSUBDOM];       /* subdomain strins. */
    char **top;               /* toplevel domain. */
} Dom;

static char *Amalloc();

/* SHUT UP! */
#define Fprintf (void) fprintf
#define Kill    (void) kill
#define Signal  (void) signal
#define Strcpy  (void) strcpy
#define Strncpy (void) strncpy
#define Strcat  (void) strcat
#define Sprintf (void) sprintf

#ifdef  __cplusplus
}
#endif

#endif /* _ADDR_H */
