
/* $Header: /cvs/faces/faces/faces/face_socket.h,v 1.2 2002/01/15 22:58:46 devface Exp $
 *
 * This module is a massivily modified version of mutt_socket.c
 * found in the mutt mailreader.  The origional copyrights read:
 *
 * Copyright (C) 1998 Brandon Long <blong@fiction.net>
 * Copyright (C) 1999-2001 Brendan Cully <brendan@kublai.com>
 * 
 * Mutt is distributed under the FSF GNU General Public Licence.  The
 * Mutt program itself can be found at http://www.mutt.org/.
 *
 * This version is
 *  Copyright (C) 2001-2002  Robert Adams (misterblue@misterblue.com)
 *  All rights reserved.
 *
 *  Permission is given to distribute these sources, as long as the
 *  copyright messages are not removed, and no monies are exchanged. 
 * 
 *  No responsibility is taken for any errors on inaccuracies inherent
 *  either to the comments or the code of this program, but if reported
 *  to me, then an attempt will be made to fix them.
 *
 */ 

#ifndef _FACE_SOCKET_H_
#define _FACE_SOCKET_H_ 1

/* logging levels */
#define M_SOCK_LOG_CMD  2
#define M_SOCK_LOG_HDR  3
#define M_SOCK_LOG_FULL 4

#ifndef LONG_STRING
#define LONG_STRING 1024
#endif

typedef struct _connection {
    char inbuf[LONG_STRING];
    int bufpos;
    int available;

    int fd;

    char *host;
    int port;
    int (*read) (struct _connection *conn, char *buf, size_t len);
    int (*write) (struct _connection *conn, const char *buf, size_t count);
    int (*open) (struct _connection *conn);
    int (*close) (struct _connection *conn);
} CONNECTION;

CONNECTION* build_connection(char*, int);
int free_connection(CONNECTION *);

int face_socket_readchar(CONNECTION *, char*);
int face_socket_readln(CONNECTION *, char*, size_t);

int face_socket_open(CONNECTION *);
int face_socket_close(CONNECTION *);
int face_socket_read(CONNECTION *, char *, size_t);
int face_socket_readchar(CONNECTION *, char *);
int face_socket_write(CONNECTION *, const char *, int);

int raw_socket_read(CONNECTION*, char *, size_t);
int raw_socket_write(CONNECTION*, const char *, size_t);
int raw_socket_open(CONNECTION *);
int raw_socket_close(CONNECTION *);

#endif /*_FACE_SOCKET_H_*/
